if(!Tonyu.load)Tonyu.load=(_,f)=>f();
Tonyu.load({"compiler":{"namespace":"user","defaultSuperClass":"kernel.Actor","dependingProjects":[{"namespace":"kernel"}]},"run":{"mainClass":"user.Main","bootClass":"kernel.Boot","globals":{"$defaultFPS":60,"$imageSmoothingDisabled":true,"$soundLoadAndDecode":false}},"plugins":{},"kernelEditable":false,"language":"tonyu","version":1719213854291}, ()=>{
Tonyu.klass.define({
  fullName: 'user.Aim',
  shortName: 'Aim',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Aim_main() {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+3;
        _this.zOrder=(- 10);
        _this.crashScale=0.5;
        _this.scaleX=1;
        _this.scaleY=1;
        while (true) {
          Tonyu.checkLoop();
          _this.x=Tonyu.globals.$mouseX;
          _this.y=Tonyu.globals.$mouseY;
          if (! Tonyu.globals.$touches[0].touched==1) {
            _this.hide();
            
          } else {
            _this.show();
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Aim_f_main(_thread) {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+3;
        _this.zOrder=(- 10);
        _this.crashScale=0.5;
        _this.scaleX=1;
        _this.scaleY=1;
        while (true) {
          yield null;
          _this.x=Tonyu.globals.$mouseX;
          _this.y=Tonyu.globals.$mouseY;
          if (! Tonyu.globals.$touches[0].touched==1) {
            _this.hide();
            
          } else {
            _this.show();
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Bullet',
  shortName: 'Bullet',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Bullet_main() {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.scaleX=1;
        _this.scaleY=1;
        _this.dir=_this.atanxy(_this.dx,_this.dy);
        _this.vx=_this.cos(_this.dir)*10;
        _this.vy=_this.sin(_this.dir)*10;
        while (! _this.screenOut()) {
          Tonyu.checkLoop();
          _this.rotation=_this.dir+90;
          _this.x+=_this.vx;
          _this.y+=_this.vy;
          _this.update();
          _this.cMob=_this.crashTo(Tonyu.classes.user.Mob);
          if (_this.crashTo(Tonyu.classes.user.Mob)) {
            _this.die();
          }
          
        }
        _this.die();
      },
      fiber$main :function* _trc_Bullet_f_main(_thread) {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.scaleX=1;
        _this.scaleY=1;
        _this.dir=_this.atanxy(_this.dx,_this.dy);
        _this.vx=_this.cos(_this.dir)*10;
        _this.vy=_this.sin(_this.dir)*10;
        while (! _this.screenOut()) {
          yield null;
          _this.rotation=_this.dir+90;
          _this.x+=_this.vx;
          _this.y+=_this.vy;
          (yield* _this.fiber$update(_thread));
          _this.cMob=_this.crashTo(Tonyu.classes.user.Mob);
          if (_this.crashTo(Tonyu.classes.user.Mob)) {
            _this.die();
          }
          
        }
        _this.die();
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{"dir":{},"dx":{},"dy":{},"vx":{},"vy":{},"cMob":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Item',
  shortName: 'Item',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Item_main() {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.counter=0;
        while (true) {
          Tonyu.checkLoop();
          _this.counter++;
          if (_this.floor(_this.counter/240)) {
            _this.die();
          }
          _this.cAim=_this.crashTo(Tonyu.classes.user.Aim);
          if ((! Tonyu.globals.$touches[0].touched==0)&&(_this.cAim)) {
            _this.parallel("animate");
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Item_f_main(_thread) {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.counter=0;
        while (true) {
          yield null;
          _this.counter++;
          if (_this.floor(_this.counter/240)) {
            _this.die();
          }
          _this.cAim=_this.crashTo(Tonyu.classes.user.Aim);
          if ((! Tonyu.globals.$touches[0].touched==0)&&(_this.cAim)) {
            _this.parallel("animate");
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      animate :function _trc_Item_animate() {
        var _this=this;
        
        _this.counter=0;
        while (true) {
          Tonyu.checkLoop();
          _this.counter++;
          _this.y--;
          if (_this.floor(_this.counter/60)) {
            Tonyu.globals.$pp+=(1);
            _this.die();
            
          }
          _this.update();
          
        }
      },
      fiber$animate :function* _trc_Item_f_animate(_thread) {
        var _this=this;
        
        _this.counter=0;
        while (true) {
          yield null;
          _this.counter++;
          _this.y--;
          if (_this.floor(_this.counter/60)) {
            Tonyu.globals.$pp+=(1);
            _this.die();
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"animate":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"counter":{},"cAim":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        var _this=this;
        
        _this.print("ShirohageTowerDefense version0.05 alpha");
        _this.update();
        Tonyu.globals.$Screen.resize(1024,1024+512);
        Tonyu.globals.$Screen.setBGColor("lightgreen");
        Tonyu.globals.$aim=new Tonyu.classes.user.Aim;
        new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,radius: 256,fillStyle: "#4c4",zOrder: (2)});
        Tonyu.globals.$attack=9;
        Tonyu.globals.$wave=_this.clamp(1,1,1000);
        Tonyu.globals.$pp=8181;
        Tonyu.globals.$healthPlice=1;
        Tonyu.globals.$armPlice=5;
        Tonyu.globals.$ep=0;
        Tonyu.globals.$brankPlice=0;
        {
          new Tonyu.classes.kernel.Label({template: "$pp PP",x: Tonyu.globals.$screenWidth/2-128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          new Tonyu.classes.kernel.Label({template: "$ep EP",x: Tonyu.globals.$screenWidth/2+128,y: (16),size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          new Tonyu.classes.kernel.Label({template: "WAVE:$wave",x: Tonyu.globals.$screenWidth/2,y: (16)+64,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          _this.fb=new Tonyu.classes.kernel.Button({text: "",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",layer: Tonyu.globals.$frontLayer,zOrder: (- 10),left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_1183() {
            
            _this.update();
            _this.flyer.die();
            _this.fb.die();
          })});
          _this.flyer=new Tonyu.classes.kernel.Actor({p: Tonyu.globals.$pat_flyer1,x: (Tonyu.globals.$screenWidth/2),y: (Tonyu.globals.$screenHeight/2),layer: Tonyu.globals.$frontLayer,zOrder: (- 10)});
        }
        _this.phases=("standby");
        _this.Standby();
        _this.parallel("TowerHP");
        _this.parallel("MobLength");
        while (true) {
          Tonyu.checkLoop();
          if ((! _this.all(Tonyu.classes.user.Mob).length>=1)&&(_this.phases==("wave"))) {
            _this.Healing();
            _this.updateEx(120);
            Tonyu.globals.$wave+=1;
            _this.Wave();
            
          }
          if ((_this.all(Tonyu.classes.user.Tower).length==0)&&(_this.phases==("wave"))) {
            _this.Defeat();
          }
          _this.update();
          
        }
        ;
        
        ;
        
      },
      fiber$main :function* _trc_Main_f_main(_thread) {
        var _this=this;
        
        _this.print("ShirohageTowerDefense version0.05 alpha");
        (yield* _this.fiber$update(_thread));
        Tonyu.globals.$Screen.resize(1024,1024+512);
        Tonyu.globals.$Screen.setBGColor("lightgreen");
        Tonyu.globals.$aim=new Tonyu.classes.user.Aim;
        new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,radius: 256,fillStyle: "#4c4",zOrder: (2)});
        Tonyu.globals.$attack=9;
        Tonyu.globals.$wave=_this.clamp(1,1,1000);
        Tonyu.globals.$pp=8181;
        Tonyu.globals.$healthPlice=1;
        Tonyu.globals.$armPlice=5;
        Tonyu.globals.$ep=0;
        Tonyu.globals.$brankPlice=0;
        {
          new Tonyu.classes.kernel.Label({template: "$pp PP",x: Tonyu.globals.$screenWidth/2-128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          new Tonyu.classes.kernel.Label({template: "$ep EP",x: Tonyu.globals.$screenWidth/2+128,y: (16),size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          new Tonyu.classes.kernel.Label({template: "WAVE:$wave",x: Tonyu.globals.$screenWidth/2,y: (16)+64,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
          _this.fb=new Tonyu.classes.kernel.Button({text: "",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",layer: Tonyu.globals.$frontLayer,zOrder: (- 10),left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_1183() {
            
            _this.update();
            _this.flyer.die();
            _this.fb.die();
          })});
          _this.flyer=new Tonyu.classes.kernel.Actor({p: Tonyu.globals.$pat_flyer1,x: (Tonyu.globals.$screenWidth/2),y: (Tonyu.globals.$screenHeight/2),layer: Tonyu.globals.$frontLayer,zOrder: (- 10)});
        }
        _this.phases=("standby");
        (yield* _this.fiber$Standby(_thread));
        _this.parallel("TowerHP");
        _this.parallel("MobLength");
        while (true) {
          yield null;
          if ((! _this.all(Tonyu.classes.user.Mob).length>=1)&&(_this.phases==("wave"))) {
            (yield* _this.fiber$Healing(_thread));
            (yield* _this.fiber$updateEx(_thread, 120));
            Tonyu.globals.$wave+=1;
            (yield* _this.fiber$Wave(_thread));
            
          }
          if ((_this.all(Tonyu.classes.user.Tower).length==0)&&(_this.phases==("wave"))) {
            (yield* _this.fiber$Defeat(_thread));
          }
          (yield* _this.fiber$update(_thread));
          
        }
        ;
        
        ;
        
        
      },
      Standby :function _trc_Main_Standby() {
        var _this=this;
        
        _this.phases=("standby");
        _this.print("phases:"+_this.phases);
        Tonyu.globals.$lBar+=((Tonyu.globals.$lDamage)*1);
        Tonyu.globals.$hp+=((1)*1);
        Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
        _this.Pupgrade();
        new Tonyu.classes.kernel.Label({template: "READY?",x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2-256,size: 128,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Button({text: "GO!",fillStyle: "#000",strokeStyle: "#fff",clickedStyle: "#000",left: (Tonyu.globals.$screenWidth/2)-240,top: (Tonyu.globals.$screenHeight/2)+96,width: 480,height: 128,padding: 8,onClick: (function anonymous_2265() {
          
          _this.Alldie();
          _this.Eupgrade();
          _this.Wave();
        })});
      },
      fiber$Standby :function* _trc_Main_f_Standby(_thread) {
        var _this=this;
        
        _this.phases=("standby");
        _this.print("phases:"+_this.phases);
        Tonyu.globals.$lBar+=((Tonyu.globals.$lDamage)*1);
        Tonyu.globals.$hp+=((1)*1);
        Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
        (yield* _this.fiber$Pupgrade(_thread));
        new Tonyu.classes.kernel.Label({template: "READY?",x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2-256,size: 128,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Button({text: "GO!",fillStyle: "#000",strokeStyle: "#fff",clickedStyle: "#000",left: (Tonyu.globals.$screenWidth/2)-240,top: (Tonyu.globals.$screenHeight/2)+96,width: 480,height: 128,padding: 8,onClick: (function anonymous_2265() {
          
          _this.Alldie();
          _this.Eupgrade();
          _this.Wave();
        })});
        
      },
      Wave :function _trc_Main_Wave() {
        var _this=this;
        
        _this.phases=("wave");
        _this.print("phases:"+_this.phases);
        _this.appear(Tonyu.classes.user.Mob);
        Tonyu.globals.$mlmax=(5+Tonyu.globals.$wave);
        Tonyu.globals.$mDamage=(400/Tonyu.globals.$mlmax);
        Tonyu.globals.$mBar=(Tonyu.globals.$mDamage*Tonyu.globals.$mlmax);
        for (_this.i=1; _this.i<Tonyu.globals.$mlmax ; _this.i++) {
          Tonyu.checkLoop();
          _this.appear(Tonyu.classes.user.Mob);
        }
      },
      fiber$Wave :function* _trc_Main_f_Wave(_thread) {
        var _this=this;
        
        _this.phases=("wave");
        _this.print("phases:"+_this.phases);
        _this.appear(Tonyu.classes.user.Mob);
        Tonyu.globals.$mlmax=(5+Tonyu.globals.$wave);
        Tonyu.globals.$mDamage=(400/Tonyu.globals.$mlmax);
        Tonyu.globals.$mBar=(Tonyu.globals.$mDamage*Tonyu.globals.$mlmax);
        for (_this.i=1; _this.i<Tonyu.globals.$mlmax ; _this.i++) {
          yield null;
          _this.appear(Tonyu.classes.user.Mob);
        }
        
      },
      Defeat :function _trc_Main_Defeat() {
        var _this=this;
        
        _this.phases=("defeat");
        _this.print("phases:"+_this.phases);
        new Tonyu.classes.kernel.Button({text: "DEFEAT...",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_2792() {
          
          _this.Alldie();
          if (Tonyu.globals.$wave>1) {
            Tonyu.globals.$wave--;
          }
          _this.Standby();
        })});
      },
      fiber$Defeat :function* _trc_Main_f_Defeat(_thread) {
        var _this=this;
        
        _this.phases=("defeat");
        _this.print("phases:"+_this.phases);
        new Tonyu.classes.kernel.Button({text: "DEFEAT...",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_2792() {
          
          _this.Alldie();
          if (Tonyu.globals.$wave>1) {
            Tonyu.globals.$wave--;
          }
          _this.Standby();
        })});
        
      },
      Alldie :function _trc_Main_Alldie() {
        var _this=this;
        
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Label).die();
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Button).die();
        _this.all(Tonyu.classes.user.Mob).die();
      },
      fiber$Alldie :function* _trc_Main_f_Alldie(_thread) {
        var _this=this;
        
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Label).die();
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Button).die();
        _this.all(Tonyu.classes.user.Mob).die();
        
      },
      Healing :function _trc_Main_Healing() {
        var _this=this;
        
        Tonyu.globals.$lBar+=(200/5);
        Tonyu.globals.$hp+=(Tonyu.globals.$hpmax/5);
      },
      fiber$Healing :function* _trc_Main_f_Healing(_thread) {
        var _this=this;
        
        Tonyu.globals.$lBar+=(200/5);
        Tonyu.globals.$hp+=(Tonyu.globals.$hpmax/5);
        
      },
      TowerHP :function _trc_Main_TowerHP() {
        var _this=this;
        
        _this.lGauge=new Tonyu.classes.kernel.Panel;
        _this.lGauge.resize(200,32);
        Tonyu.globals.$lBar=200;
        Tonyu.globals.$hpmax=10;
        Tonyu.globals.$lDamage=(Tonyu.globals.$lBar/Tonyu.globals.$hpmax);
        Tonyu.globals.$hp=(Tonyu.globals.$hpmax);
        new Tonyu.classes.kernel.Label({template: "$hp/$hpmax",x: (Tonyu.globals.$screenWidth/2),y: (Tonyu.globals.$screenHeight/2)-96,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        while (true) {
          Tonyu.checkLoop();
          if (Tonyu.globals.$hp<=0) {
            
            
          }
          if (_this.getkey("d")==1) {
            Tonyu.globals.$lBar-=((Tonyu.globals.$lDamage)*1);
            Tonyu.globals.$hp-=((1)*1);
            
          }
          if (_this.getkey("h")==1) {
            Tonyu.globals.$lBar+=((Tonyu.globals.$lDamage)*1);
            Tonyu.globals.$hp+=((1)*1);
            
          }
          if (Tonyu.globals.$lBar>200) {
            Tonyu.globals.$lBar=200;
            
          }
          if (Tonyu.globals.$hp>Tonyu.globals.$hpmax) {
            Tonyu.globals.$hp=Tonyu.globals.$hpmax;
            
          }
          if (Tonyu.globals.$lBar<0) {
            Tonyu.globals.$lBar=0;
            
          }
          if (Tonyu.globals.$hp<0) {
            Tonyu.globals.$hp=0;
            
          }
          _this.lGauge.x=Tonyu.globals.$screenWidth/2;
          _this.lGauge.y=Tonyu.globals.$screenHeight/2-80;
          _this.lGauge.fillStyle="#000";
          _this.lGauge.fillRect(0,0,200,32);
          _this.lGauge.fillStyle="#f00";
          _this.lGauge.fillRect(0,0,Tonyu.globals.$lBar,32);
          _this.update();
          
        }
      },
      fiber$TowerHP :function* _trc_Main_f_TowerHP(_thread) {
        var _this=this;
        
        _this.lGauge=new Tonyu.classes.kernel.Panel;
        _this.lGauge.resize(200,32);
        Tonyu.globals.$lBar=200;
        Tonyu.globals.$hpmax=10;
        Tonyu.globals.$lDamage=(Tonyu.globals.$lBar/Tonyu.globals.$hpmax);
        Tonyu.globals.$hp=(Tonyu.globals.$hpmax);
        new Tonyu.classes.kernel.Label({template: "$hp/$hpmax",x: (Tonyu.globals.$screenWidth/2),y: (Tonyu.globals.$screenHeight/2)-96,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        while (true) {
          yield null;
          if (Tonyu.globals.$hp<=0) {
            
            
          }
          if (_this.getkey("d")==1) {
            Tonyu.globals.$lBar-=((Tonyu.globals.$lDamage)*1);
            Tonyu.globals.$hp-=((1)*1);
            
          }
          if (_this.getkey("h")==1) {
            Tonyu.globals.$lBar+=((Tonyu.globals.$lDamage)*1);
            Tonyu.globals.$hp+=((1)*1);
            
          }
          if (Tonyu.globals.$lBar>200) {
            Tonyu.globals.$lBar=200;
            
          }
          if (Tonyu.globals.$hp>Tonyu.globals.$hpmax) {
            Tonyu.globals.$hp=Tonyu.globals.$hpmax;
            
          }
          if (Tonyu.globals.$lBar<0) {
            Tonyu.globals.$lBar=0;
            
          }
          if (Tonyu.globals.$hp<0) {
            Tonyu.globals.$hp=0;
            
          }
          _this.lGauge.x=Tonyu.globals.$screenWidth/2;
          _this.lGauge.y=Tonyu.globals.$screenHeight/2-80;
          _this.lGauge.fillStyle="#000";
          _this.lGauge.fillRect(0,0,200,32);
          _this.lGauge.fillStyle="#f00";
          _this.lGauge.fillRect(0,0,Tonyu.globals.$lBar,32);
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      MobLength :function _trc_Main_MobLength() {
        var _this=this;
        
        _this.mGauge=new Tonyu.classes.kernel.Panel;
        _this.mGauge.resize(400,32);
        Tonyu.globals.$mBar=0;
        Tonyu.globals.$mlmax=0;
        Tonyu.globals.$mDamage=(Tonyu.globals.$mBar/Tonyu.globals.$mlmax);
        Tonyu.globals.$ml=0;
        new Tonyu.classes.kernel.Label({template: "$ml/$mlmax",x: (Tonyu.globals.$screenWidth/2),y: (16)+32,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        while (true) {
          Tonyu.checkLoop();
          if (_this.all(Tonyu.classes.user.Mob).length>0) {
            Tonyu.globals.$ml=_this.all(Tonyu.classes.user.Mob).length;
            
          } else {
            Tonyu.globals.$mBar=0;
            Tonyu.globals.$ml=_this.all(Tonyu.classes.user.Mob).length;
            Tonyu.globals.$mlmax=Tonyu.globals.$wave;
            
          }
          _this.mGauge.x=(Tonyu.globals.$screenWidth/2);
          _this.mGauge.y=(64);
          _this.mGauge.fillStyle="#000";
          _this.mGauge.fillRect(0,0,400,32);
          _this.mGauge.fillStyle="#088";
          _this.mGauge.fillRect(0,0,Tonyu.globals.$mBar,32);
          _this.update();
          
        }
      },
      fiber$MobLength :function* _trc_Main_f_MobLength(_thread) {
        var _this=this;
        
        _this.mGauge=new Tonyu.classes.kernel.Panel;
        _this.mGauge.resize(400,32);
        Tonyu.globals.$mBar=0;
        Tonyu.globals.$mlmax=0;
        Tonyu.globals.$mDamage=(Tonyu.globals.$mBar/Tonyu.globals.$mlmax);
        Tonyu.globals.$ml=0;
        new Tonyu.classes.kernel.Label({template: "$ml/$mlmax",x: (Tonyu.globals.$screenWidth/2),y: (16)+32,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        while (true) {
          yield null;
          if (_this.all(Tonyu.classes.user.Mob).length>0) {
            Tonyu.globals.$ml=_this.all(Tonyu.classes.user.Mob).length;
            
          } else {
            Tonyu.globals.$mBar=0;
            Tonyu.globals.$ml=_this.all(Tonyu.classes.user.Mob).length;
            Tonyu.globals.$mlmax=Tonyu.globals.$wave;
            
          }
          _this.mGauge.x=(Tonyu.globals.$screenWidth/2);
          _this.mGauge.y=(64);
          _this.mGauge.fillStyle="#000";
          _this.mGauge.fillRect(0,0,400,32);
          _this.mGauge.fillStyle="#088";
          _this.mGauge.fillRect(0,0,Tonyu.globals.$mBar,32);
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      Popup :function _trc_Main_Popup() {
        var _this=this;
        
        _this.counter=1;
        while (_this.counter<Tonyu.globals.$mlmax) {
          Tonyu.checkLoop();
          _this.updateEx(30);
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.appear(Tonyu.classes.user.Mob);
            Tonyu.globals.$mBar+=Tonyu.globals.$mDamage;
            _this.counter++;
            _this.dice=0;
            
          }
          _this.update();
          
        }
      },
      fiber$Popup :function* _trc_Main_f_Popup(_thread) {
        var _this=this;
        
        _this.counter=1;
        while (_this.counter<Tonyu.globals.$mlmax) {
          yield null;
          (yield* _this.fiber$updateEx(_thread, 30));
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.appear(Tonyu.classes.user.Mob);
            Tonyu.globals.$mBar+=Tonyu.globals.$mDamage;
            _this.counter++;
            _this.dice=0;
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      Pupgrade :function _trc_Main_Pupgrade() {
        var _this=this;
        
        _this.bWidth=256;
        new Tonyu.classes.kernel.Button({text: "💖",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 48,onClick: (function anonymous_5354() {
          
          if (Tonyu.globals.$pp>=(Tonyu.globals.$healthPlice)) {
            Tonyu.globals.$pp-=Tonyu.globals.$healthPlice;
            Tonyu.globals.$healthPlice*=2;
            Tonyu.globals.$hpmax+=10;
            Tonyu.globals.$lDamage=(200/Tonyu.globals.$hpmax);
            Tonyu.globals.$lBar=Tonyu.globals.$lDamage*Tonyu.globals.$hp;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "💪",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 48,onClick: (function anonymous_5790() {
          
          if (Tonyu.globals.$pp>=(Tonyu.globals.$armPlice)) {
            Tonyu.globals.$pp-=Tonyu.globals.$armPlice;
            Tonyu.globals.$armPlice*=2;
            Tonyu.globals.$attack+=1;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6141() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6354() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "HEALTH\n$hpmax\n\n\n\n\n"+"$healthPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "STRONG\n$attack\n\n\n\n\n"+"$armPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
      },
      fiber$Pupgrade :function* _trc_Main_f_Pupgrade(_thread) {
        var _this=this;
        
        _this.bWidth=256;
        new Tonyu.classes.kernel.Button({text: "💖",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 48,onClick: (function anonymous_5354() {
          
          if (Tonyu.globals.$pp>=(Tonyu.globals.$healthPlice)) {
            Tonyu.globals.$pp-=Tonyu.globals.$healthPlice;
            Tonyu.globals.$healthPlice*=2;
            Tonyu.globals.$hpmax+=10;
            Tonyu.globals.$lDamage=(200/Tonyu.globals.$hpmax);
            Tonyu.globals.$lBar=Tonyu.globals.$lDamage*Tonyu.globals.$hp;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "💪",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 48,onClick: (function anonymous_5790() {
          
          if (Tonyu.globals.$pp>=(Tonyu.globals.$armPlice)) {
            Tonyu.globals.$pp-=Tonyu.globals.$armPlice;
            Tonyu.globals.$armPlice*=2;
            Tonyu.globals.$attack+=1;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6141() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6354() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "HEALTH\n$hpmax\n\n\n\n\n"+"$healthPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "STRONG\n$attack\n\n\n\n\n"+"$armPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
        
      },
      Eupgrade :function _trc_Main_Eupgrade() {
        var _this=this;
        
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_7233() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_7449() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_7665() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_7881() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
      },
      fiber$Eupgrade :function* _trc_Main_f_Eupgrade(_thread) {
        var _this=this;
        
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_7233() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_7449() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_7665() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_7881() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"Standby":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Wave":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Defeat":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Alldie":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Healing":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"TowerHP":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"MobLength":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Popup":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Pupgrade":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Eupgrade":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"fb":{},"flyer":{},"phases":{},"i":{},"lGauge":{},"mGauge":{},"counter":{},"dice":{},"bWidth":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Mob',
  shortName: 'Mob',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Mob_main() {
        var _this=this;
        
        _this.dice=_this.rnd(2);
        if (_this.dice==1) {
          _this.p=Tonyu.globals.$pat_pad128+4;
        } else {
          _this.p=Tonyu.globals.$pat_pad128+5;
        }
        _this.zOrder=1;
        _this.dice=_this.rnd(2);
        if (_this.dice==1) {
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.x=(- 512)+_this.rnd(256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          } else {
            _this.x=(Tonyu.globals.$screenWidth)+256+_this.rnd(256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          }
          
        } else {
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(- 384)+_this.rnd(256);
            
          } else {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(Tonyu.globals.$screenHeight)+128+_this.rnd(256);
            
          }
          
        }
        ;
        
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.c=0;
        _this.dir=0;
        _this.gauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.gauge.resize(100,10);
        _this.bar=100;
        _this.hp=[10,10];
        _this.ldamage=(_this.bar/_this.hp[0])*Tonyu.globals.$attack;
        while (true) {
          Tonyu.checkLoop();
          if (_this.bar<=0) {
            _this.appear(new Tonyu.classes.user.Item({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+7}));
            Tonyu.globals.$mBar-=Tonyu.globals.$mDamage;
            _this.die();
            
          }
          if (! _this.crashTo(Tonyu.classes.user.Tower)) {
            _this.x+=_this.cos(_this.dir);
            _this.y+=_this.sin(_this.dir);
            _this.tx=Tonyu.globals.$tower.x;
            _this.ty=Tonyu.globals.$tower.y;
            _this.tdir=_this.atanxy(_this.tx-_this.x,_this.ty-_this.y);
            _this.d=_this.angleDiff(_this.dir,_this.tdir);
            if (_this.d>0) {
              _this.dir-=2;
            } else {
              _this.dir+=2;
            }
            
          } else {
            if (_this.c<=0) {
              _this.c=60;
              Tonyu.globals.$lBar-=((Tonyu.globals.$lDamage)*(Tonyu.globals.$wave));
              Tonyu.globals.$hp-=((1)*(Tonyu.globals.$wave));
              
            }
          }
          if (_this.c>0) {
            _this.c--;
          }
          if (_this.c%2==0) {
            _this.alpha=255;
          } else {
            _this.alpha=0;
          }
          _this.gauge.x=_this.x;
          _this.gauge.y=_this.y-64;
          _this.gauge.fillStyle="#000";
          _this.gauge.fillRect(0,0,100,10);
          _this.gauge.fillStyle="#f00";
          _this.gauge.fillRect(1,1,_this.bar-2,10-2);
          if (_this.crashTo(Tonyu.classes.user.Bullet)) {
            _this.bar-=_this.ldamage;
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Mob_f_main(_thread) {
        var _this=this;
        
        _this.dice=_this.rnd(2);
        if (_this.dice==1) {
          _this.p=Tonyu.globals.$pat_pad128+4;
        } else {
          _this.p=Tonyu.globals.$pat_pad128+5;
        }
        _this.zOrder=1;
        _this.dice=_this.rnd(2);
        if (_this.dice==1) {
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.x=(- 512)+_this.rnd(256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          } else {
            _this.x=(Tonyu.globals.$screenWidth)+256+_this.rnd(256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          }
          
        } else {
          _this.dice=_this.rnd(2);
          if (_this.dice==1) {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(- 384)+_this.rnd(256);
            
          } else {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(Tonyu.globals.$screenHeight)+128+_this.rnd(256);
            
          }
          
        }
        ;
        
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.c=0;
        _this.dir=0;
        _this.gauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.gauge.resize(100,10);
        _this.bar=100;
        _this.hp=[10,10];
        _this.ldamage=(_this.bar/_this.hp[0])*Tonyu.globals.$attack;
        while (true) {
          yield null;
          if (_this.bar<=0) {
            _this.appear(new Tonyu.classes.user.Item({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+7}));
            Tonyu.globals.$mBar-=Tonyu.globals.$mDamage;
            _this.die();
            
          }
          if (! _this.crashTo(Tonyu.classes.user.Tower)) {
            _this.x+=_this.cos(_this.dir);
            _this.y+=_this.sin(_this.dir);
            _this.tx=Tonyu.globals.$tower.x;
            _this.ty=Tonyu.globals.$tower.y;
            _this.tdir=_this.atanxy(_this.tx-_this.x,_this.ty-_this.y);
            _this.d=_this.angleDiff(_this.dir,_this.tdir);
            if (_this.d>0) {
              _this.dir-=2;
            } else {
              _this.dir+=2;
            }
            
          } else {
            if (_this.c<=0) {
              _this.c=60;
              Tonyu.globals.$lBar-=((Tonyu.globals.$lDamage)*(Tonyu.globals.$wave));
              Tonyu.globals.$hp-=((1)*(Tonyu.globals.$wave));
              
            }
          }
          if (_this.c>0) {
            _this.c--;
          }
          if (_this.c%2==0) {
            _this.alpha=255;
          } else {
            _this.alpha=0;
          }
          _this.gauge.x=_this.x;
          _this.gauge.y=_this.y-64;
          _this.gauge.fillStyle="#000";
          _this.gauge.fillRect(0,0,100,10);
          _this.gauge.fillStyle="#f00";
          _this.gauge.fillRect(1,1,_this.bar-2,10-2);
          if (_this.crashTo(Tonyu.classes.user.Bullet)) {
            _this.bar-=_this.ldamage;
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{"dice":{},"c":{},"dir":{},"gauge":{},"bar":{},"hp":{},"ldamage":{},"tx":{},"ty":{},"tdir":{},"d":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Tower',
  shortName: 'Tower',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Tower_main() {
        var _this=this;
        
        _this.update();
        _this.p=Tonyu.globals.$pat_pad128+1;
        _this.zOrder=2;
        _this.x=Tonyu.globals.$screenWidth/2;
        _this.y=Tonyu.globals.$screenHeight/2;
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.iGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.iGauge.resize(100,10);
        _this.iBar=_this.clamp(100,0,100);
        _this.ip=(120);
        _this.idamage=(_this.iBar/_this.ip);
        _this.iBar=0;
        _this.ip=0;
        _this.parallel("AutoShot");
        while (true) {
          Tonyu.checkLoop();
          if (Tonyu.globals.$hp<=0) {
            _this.die();
          }
          if (_this.iBar<100) {
            _this.iBar+=_this.idamage;
            _this.ip+=1;
            
          }
          if (Tonyu.globals.$touches[0].touched==0) {
            
            
          } else {
            if (_this.ip>120) {
              _this.iBar=0;
              _this.ip=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8,dx: Tonyu.globals.$aim.x-_this.x,dy: Tonyu.globals.$aim.y-_this.y});
              
            }
          }
          _this.iGauge.x=Tonyu.globals.$screenWidth/2;
          _this.iGauge.y=_this.y+64;
          _this.iGauge.fillStyle="#000";
          _this.iGauge.fillRect(0,0,100,10);
          _this.iGauge.fillStyle="#0f0";
          _this.iGauge.fillRect(1,1,_this.iBar-3,10-2);
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Tower_f_main(_thread) {
        var _this=this;
        
        (yield* _this.fiber$update(_thread));
        _this.p=Tonyu.globals.$pat_pad128+1;
        _this.zOrder=2;
        _this.x=Tonyu.globals.$screenWidth/2;
        _this.y=Tonyu.globals.$screenHeight/2;
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.iGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.iGauge.resize(100,10);
        _this.iBar=_this.clamp(100,0,100);
        _this.ip=(120);
        _this.idamage=(_this.iBar/_this.ip);
        _this.iBar=0;
        _this.ip=0;
        _this.parallel("AutoShot");
        while (true) {
          yield null;
          if (Tonyu.globals.$hp<=0) {
            _this.die();
          }
          if (_this.iBar<100) {
            _this.iBar+=_this.idamage;
            _this.ip+=1;
            
          }
          if (Tonyu.globals.$touches[0].touched==0) {
            
            
          } else {
            if (_this.ip>120) {
              _this.iBar=0;
              _this.ip=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8,dx: Tonyu.globals.$aim.x-_this.x,dy: Tonyu.globals.$aim.y-_this.y});
              
            }
          }
          _this.iGauge.x=Tonyu.globals.$screenWidth/2;
          _this.iGauge.y=_this.y+64;
          _this.iGauge.fillStyle="#000";
          _this.iGauge.fillRect(0,0,100,10);
          _this.iGauge.fillStyle="#0f0";
          _this.iGauge.fillRect(1,1,_this.iBar-3,10-2);
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      AutoShot :function _trc_Tower_AutoShot() {
        var _this=this;
        
        _this.AutoInt=0;
        while (true) {
          Tonyu.checkLoop();
          _this.AutoInt++;
          for ([_this.t] of Tonyu.iterator2(_this.allWithin(Tonyu.classes.user.Mob,256),1)) {
            if (_this.AutoInt>150) {
              _this.AutoInt=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8,dx: _this.t.x-_this.x,dy: _this.t.y-_this.y});
              
            }
            
          }
          _this.update();
          
        }
      },
      fiber$AutoShot :function* _trc_Tower_f_AutoShot(_thread) {
        var _this=this;
        
        _this.AutoInt=0;
        while (true) {
          yield null;
          _this.AutoInt++;
          for ([_this.t] of Tonyu.iterator2(_this.allWithin(Tonyu.classes.user.Mob,256),1)) {
            if (_this.AutoInt>150) {
              _this.AutoInt=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8,dx: _this.t.x-_this.x,dy: _this.t.y-_this.y});
              
            }
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"AutoShot":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"iGauge":{},"iBar":{},"ip":{},"idamage":{},"AutoInt":{},"t":{}}}
});

});

//# sourceMappingURL=concat.js.map